Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaderenv.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaderenv.h	(revision 3285)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaderenv.h	(revision 3290)
@@ -8,6 +8,6 @@
 //#define NUM_SAMPLES 8
 //#define NUM_SAMPLES 16
-#define NUM_SAMPLES 24
-//#define NUM_SAMPLES 48
+//#define NUM_SAMPLES 24
+#define NUM_SAMPLES 48
 
 #define MIN_SAMPLES 8
@@ -63,5 +63,5 @@
 
 
-//#define USE_GTX
+#define USE_GTX
 
 #endif // __SHADERENV_H
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/VisibilitySolutionLoader.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/VisibilitySolutionLoader.cpp	(revision 3289)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/VisibilitySolutionLoader.cpp	(revision 3290)
@@ -156,6 +156,6 @@
 
 	BvhNodeContainer nodes;
-	//CreateIdSortedList2(bvh->GetStaticRoot(), nodes);
-	CreateIdSortedList(bvh, nodes);
+	CreateIdSortedList2(bvh->GetStaticRoot(), nodes);
+	//CreateIdSortedList(bvh, nodes);
 
 	const int tenpercent = number / 10;
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3289)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3290)
@@ -616,7 +616,7 @@
 	//LoadModel("sibenik.dem", dynamicObjects);
 
-	if (1) LoadPompeiiFloor();
-
-#if 0
+	if (0) LoadPompeiiFloor();
+
+#if 1
 	const Vector3 sceneCenter(470.398f, 240.364f, 181.7f);
 	//const Vector3 sceneCenter(470.398f, 240.364f, 180.3);
@@ -630,4 +630,5 @@
 	for (int i = 0; i < 10; ++ i)
 	{
+		cout << "here3" << endl;
 		SceneEntity *ent = new SceneEntity(*buddha);
 		resourceManager->AddSceneEntity(ent);
@@ -1119,5 +1120,5 @@
 void MainLoop() 
 {	
-	if (buddha)
+	if (0)//buddha)
 	{
 		Matrix4x4 oldTrafo = buddha->GetTransform()->GetMatrix();
@@ -1141,5 +1142,4 @@
 #endif
 
-		/*
 		/////////////////////////
 		//-- update animations
@@ -1152,5 +1152,4 @@
 
 		motionPath->Move(0.01f);
-		*/
 	}
 
@@ -2394,9 +2393,9 @@
 			{			
 				sprintf(msg[7], "%s:  %6.1f fps", alg_str[renderMode], fps);		
-				myfont.DrawString(msg[7], 1.3f, winWidth - 350, winHeight - 30.0f);
+				myfont.DrawString(msg[7], 1.3f, winWidth - 300, winHeight - 10.0f);
 
 				//int mrays = (int)shotRays / 1000000;
 				//sprintf(msg[7], "%s:  %04d M rays", alg_str[renderMode], mrays);	
-				//myfont.DrawString(msg[7], 1.3f, winWidth - 350, winHeight - 60.0f);		
+				//myfont.DrawString(msg[7], 1.3f, winWidth - 300, winHeight - 60.0f);		
 			}
 		}
@@ -2404,5 +2403,5 @@
 		{
 			sprintf(msg[7], "%s:  %6.1f ms", alg_str[renderMode], rTime);
-			myfont.DrawString(msg[7], 1.3f, winWidth - 350, winHeight - 30.0f);
+			myfont.DrawString(msg[7], 1.3f, winWidth - 300, winHeight - 10.0f);
 		}
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj	(revision 3274)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj	(revision 3290)
@@ -155,5 +155,5 @@
 				IgnoreAllDefaultLibraries="false"
 				IgnoreDefaultLibraryNames="LIBCMT"
-				GenerateDebugInformation="false"
+				GenerateDebugInformation="true"
 				SubSystem="1"
 				LargeAddressAware="2"
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env	(revision 3289)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env	(revision 3290)
@@ -13,8 +13,8 @@
 #filename=mypompeii
 #bvhname=mypompeii
-filename=pompeii/pompeii_full
+#filename=pompeii/pompeii_full
 #filename=pompeii/pompeii_part
-#filename=city
-#bvhname=city
+filename=city
+bvhname=city
 useLODs=1
 # shadow map size
@@ -75,7 +75,7 @@
 
 # initial camera position
-#camPosition=483.398f 242.364f 186.078f
+camPosition=483.398f 242.364f 186.078f
 # pompeii view point
-camPosition=1300.0f -2500.0f 10.0f
+#camPosition=1300.0f -2500.0f 10.0f
 # pompeii problematic
 #camPosition=627.003 -1725.33 25.2
@@ -152,25 +152,25 @@
 
 # static geometry
-filename=PowerPlantM
-bvhname=PowerPlantM
-keyForwardMotion=500.0f
-mouseMotion=10.0f
-visibilitySolution=power-plant-2c-xx-1000b-pgv2
+#filename=PowerPlantM
+#bvhname=PowerPlantM
+#keyForwardMotion=500.0f
+#mouseMotion=10.0f
+#visibilitySolution=power-plant-2c-xx-1000b-pgv2
 #visibilitySolution=power-plant-2c-xx-1000d-pgv
-visibilitySolution=power-plant-2c-xx-1000b-spgvu
-camPosition=-1320.57 -6306.34 3603
-camDirection=0.292156 0.9556 0.0383878
-viewCellsScaleFactor=0.05f
+#visibilitySolution=power-plant-2c-xx-1000b-spgvu
+#camPosition=-1320.57 -6306.34 3603
+#camDirection=0.292156 0.9556 0.0383878
+#viewCellsScaleFactor=0.05f
 
-camPosition=763.554 -10254.5 2604
-camDirection=-0.0975121 0.994494 0.0383878
-useSkylightForIllum=1
-skyDomeScaleFactor=1000.0f
+#camPosition=763.554 -10254.5 2604
+#camDirection=-0.0975121 0.994494 0.0383878
+#useSkylightForIllum=1
+#skyDomeScaleFactor=1000.0f
 
-camPosition=1145.31 413.602 186.678
-camDirection=-0.917729 -0.397207 -0
+#camPosition=1145.31 413.602 186.678
+#camDirection=-0.917729 -0.397207 -0
 #lightDirection=0.509293 0.784034 -0.35484
-lightDirection=0.360937 0.0267167 -0.932207
+#lightDirection=0.360937 0.0267167 -0.932207
 
 #walkThroughSuffix=path_pp
-walkThroughSuffix=walkthrough_pp_1
+#walkThroughSuffix=walkthrough_pp_1