Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3284)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3291)
@@ -246,5 +246,5 @@
 		//-- (affects performance for some reason!)
 
-		if (1)//convergence < 700)
+		if (convergence < 700)
 		{
 			float2 mynoise = tex2Dlod(noiseTex, float4(IN.texCoord * 4.0f, 0, 0)).xy;
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SkyPreetham.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SkyPreetham.cpp	(revision 3288)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SkyPreetham.cpp	(revision 3291)
@@ -61,5 +61,7 @@
 	}
 	else
+	{
 		cerr << "sky program failed to load" << endl;
+	}
 
 	mSkyFragProgram = 
@@ -294,10 +296,13 @@
 		ambient *= 8e-6f;
 	else
+	{
 		ambient *= 1e-1f;
 
-	//  slightly too blueish => scale
-	ambient.x *= 1.3f;
-	ambient.y *= 1.1f;
-	ambient.z = max(max(ambient.z, ambient.x), ambient.y);
+		//  slightly too blueish with tone mapping => scale
+		ambient.x *= 1.3f;
+		ambient.y *= 1.1f;
+		ambient.z = max(max(ambient.z, ambient.x), ambient.y);
+	}
+	
 
 	// simulate the sun intensity by modulating the ambient term.
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.cpp	(revision 3274)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.cpp	(revision 3291)
@@ -675,4 +675,6 @@
 	// collect bvh nodes
 	BvhNodeContainer nodes;
+	// also add root
+	nodes.push_back(mRoot);
 	// first collect dynamic nodes so we make sure that they are in the beginning
 	CollectNodes(mDynamicRoot, nodes);
@@ -680,6 +682,5 @@
 	CollectNodes(mStaticRoot, nodes);
 	//CollectNodes(mRoot, nodes);
-	// also add root
-	nodes.push_back(mRoot);
+	
 
 	cout << "creating new indices" << endl;
@@ -748,4 +749,6 @@
 	// collect all nodes
 	BvhNodeContainer nodes;
+	// also add root
+	nodes.push_back(mRoot);
 	//CollectNodes(mRoot, nodes);
 	// first collect dynamic nodes so we make sure that they are in the beginning
@@ -753,6 +756,4 @@
 	// then collect static nodes
 	CollectNodes(mStaticRoot, nodes);
-	// also add root
-	nodes.push_back(mRoot);
 
 	// assign ids to all nodes of the hierarchy
@@ -773,10 +774,10 @@
 
 	nodes.reserve(GetNumNodes());
+	// also add root
+	nodes.push_back(mRoot);
 	// first collect dynamic nodes so we make sure that they are in the beginning
 	CollectNodes(mDynamicRoot, nodes);
 	// then collect static nodes
 	CollectNodes(mStaticRoot, nodes);
-	// also add root
-	nodes.push_back(mRoot);
 
 	const unsigned int bufferSize = 8 * (int)nodes.size();
@@ -828,7 +829,9 @@
 	nodes.clear();
 
-	CollectNodes(mDynamicRoot, nodes);
 	// also add root
 	nodes.push_back(mRoot);
+	
+	CollectNodes(mDynamicRoot, nodes);
+
 
 	const unsigned int bufferSize = 8 * (int)nodes.size();
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3290)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 3291)
@@ -616,7 +616,7 @@
 	//LoadModel("sibenik.dem", dynamicObjects);
 
-	if (0) LoadPompeiiFloor();
-
-#if 1
+	if (1) LoadPompeiiFloor();
+
+#if 0
 	const Vector3 sceneCenter(470.398f, 240.364f, 181.7f);
 	//const Vector3 sceneCenter(470.398f, 240.364f, 180.3);
@@ -630,5 +630,4 @@
 	for (int i = 0; i < 10; ++ i)
 	{
-		cout << "here3" << endl;
 		SceneEntity *ent = new SceneEntity(*buddha);
 		resourceManager->AddSceneEntity(ent);
@@ -1120,5 +1119,5 @@
 void MainLoop() 
 {	
-	if (0)//buddha)
+	if (buddha)
 	{
 		Matrix4x4 oldTrafo = buddha->GetTransform()->GetMatrix();
@@ -1146,10 +1145,10 @@
 
 		//const float rotAngle = M_PI * 1e-3f;
-		const float rotAngle = 1.0f * M_PI / 180.0f;
+		const float rotAngle = 0.3f * M_PI / 180.0f;
 
 		Matrix4x4 rotMatrix = RotationZMatrix(rotAngle);
-		dynamicObjects[2]->GetTransform()->MultMatrix(rotMatrix);
-
-		motionPath->Move(0.01f);
+		dynamicObjects[1]->GetTransform()->MultMatrix(rotMatrix);
+
+		motionPath->Move(0.005f);
 	}
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj	(revision 3290)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj	(revision 3291)
@@ -155,5 +155,5 @@
 				IgnoreAllDefaultLibraries="false"
 				IgnoreDefaultLibraryNames="LIBCMT"
-				GenerateDebugInformation="true"
+				GenerateDebugInformation="false"
 				SubSystem="1"
 				LargeAddressAware="2"
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env	(revision 3290)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/default.env	(revision 3291)
@@ -13,8 +13,8 @@
 #filename=mypompeii
 #bvhname=mypompeii
-#filename=pompeii/pompeii_full
+filename=pompeii/pompeii_full
 #filename=pompeii/pompeii_part
-filename=city
-bvhname=city
+#filename=city
+#bvhname=city
 useLODs=1
 # shadow map size
@@ -75,7 +75,7 @@
 
 # initial camera position
-camPosition=483.398f 242.364f 186.078f
+#camPosition=483.398f 242.364f 186.078f
 # pompeii view point
-#camPosition=1300.0f -2500.0f 10.0f
+camPosition=1300.0f -2500.0f 10.0f
 # pompeii problematic
 #camPosition=627.003 -1725.33 25.2